com.smartgwt.client.widgets.layout

## Class Portlet

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.VLayout
            - - com.smartgwt.client.widgets.Window
              - - com.smartgwt.client.widgets.layout.Portlet

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClickHandlers, HasCloseClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMaximizeClickHandlers, HasMinimizeClickHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRestoreClickHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasMembersChangedHandlers

      public class Portlet
      extends Window

  Custom subclass of Window configured to be embedded within a PortalLayout.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Portlet()`
    `Portlet(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `void` | `close()` `close()` method overridden to show `closeConfirmationMessage` to the user before removing the portlet from the PortalLayout via `PortalLayout.removePortlet()`
    `void` | `closeClick()` Handles a click on the close button of this portlet.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `Dialog` | `getCloseConfirmationDialogProperties()` If specified, this properties block will be passed to `isc.confirm()` as the properties parameter when the `closeConfirmationMessage` is shown, allowing developers to customize the appear of the confirmation dialog (modifying its title, etc).
    `java.lang.String` | `getCloseConfirmationMessage()` Confirmation message to show the user when closing portlets if `showCloseConfirmationMessage` is true.
    `java.lang.Boolean` | `getDestroyOnClose()` Whether to call `destroy()` when closing the Portlet.
    `java.lang.String` | `getEditProxyConstructor()` Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
    `java.lang.Integer` | `getHeight()` If you set the height of a Portlet, then that height will be used as the Portlet's `rowHeight` (if no rowHeight is set).
    `java.lang.String` | `getHeightAsString()` If you set the height of a Portlet, then that height will be used as the Portlet's `rowHeight` (if no rowHeight is set).
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `int` | `getMinHeight()` Specifies a minimum height for the Portlet.
    `int` | `getMinWidth()` Specifies a minimum width for the Portlet.
    `static Portlet` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `PortalLayout` | `getPortalLayout()` Gets the `PortalLayout` which encloses this Portlet (or null, if none).
    `PortalPosition` | `getPortalPosition()` Gets the position of the Portlet within its `PortalLayout`.
    `java.lang.Integer` | `getRowHeight()` If you set the rowHeight of a Portlet before adding it to a `PortalLayout`, then the height will be used when creating the new row.
    `java.lang.String` | `getRowHeightAsString()` If you set the rowHeight of a Portlet before adding it to a `PortalLayout`, then the height will be used when creating the new row.
    `java.lang.Boolean` | `getShowCloseConfirmationMessage()` If true, `closeConfirmationMessage` will be displayed before portlets are closed
    `void` | `setCloseConfirmationDialogProperties(Dialog closeConfirmationDialogProperties)` If specified, this properties block will be passed to `isc.confirm()` as the properties parameter when the `closeConfirmationMessage` is shown, allowing developers to customize the appear of the confirmation dialog (modifying its title, etc).
    `void` | `setCloseConfirmationMessage(java.lang.String closeConfirmationMessage)` Confirmation message to show the user when closing portlets if `showCloseConfirmationMessage` is true.
    `static void` | `setDefaultProperties(Portlet portletProperties)` Class level method to set the default properties of this class.
    `void` | `setDestroyOnClose(java.lang.Boolean destroyOnClose)` Whether to call `destroy()` when closing the Portlet.
    `void` | `setEditProxyConstructor(java.lang.String editProxyConstructor)` Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
    `void` | `setHeight(int height)` If you set the height of a Portlet, then that height will be used as the Portlet's `rowHeight` (if no rowHeight is set).
    `void` | `setHeight(java.lang.String height)` If you set the height of a Portlet, then that height will be used as the Portlet's `rowHeight` (if no rowHeight is set).
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.layout.PortletLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `void` | `setMinHeight(int minHeight)` Specifies a minimum height for the Portlet.
    `void` | `setMinWidth(int minWidth)` Specifies a minimum width for the Portlet.
    `void` | `setRowHeight(int rowHeight)` If you set the rowHeight of a Portlet before adding it to a `PortalLayout`, then the height will be used when creating the new row.
    `void` | `setRowHeight(java.lang.String rowHeight)` If you set the rowHeight of a Portlet before adding it to a `PortalLayout`, then the height will be used when creating the new row.
    `void` | `setShowCloseConfirmationMessage(java.lang.Boolean showCloseConfirmationMessage)` If true, `closeConfirmationMessage` will be displayed before portlets are closed

    - ### Methods inherited from class com.smartgwt.client.widgets.Window

      `addCloseClickHandler, addItem, addItem, addMaximizeClickHandler, addMember, addMember, addMinimizeClickHandler, addRestoreClickHandler, centerInPage, flash, getAnimateMinimize, getAutoCenter, getAutoSize, getBody, getBodyColor, getBodyStyle, getBringToFrontOnMouseUp, getCanDragReposition, getCanDragResize, getCanFocusInHeaderButtons, getCloseButton, getContentLayout, getContentsType, getDefaultMinimizeHeight, getDismissOnEscape, getDismissOnOutsideClick, getFillSpaceStyleName, getFooter, getFooterHeight, getHeader, getHeaderBackground, getHeaderIcon, getHeaderLabel, getHeaderSrc, getHeaderStyle, getHiliteBodyColor, getHiliteHeaderSrc, getHiliteHeaderStyle, getIsModal, getItems, getMaximizeButton, getMaximized, getMinimizeAcceleration, getMinimizeButton, getMinimized, getMinimizeHeight, getMinimizeTime, getModalMask, getModalMaskOpacity, getModalMaskStyle, getOpacity, getPlacement, getPrintBodyStyle, getPrintHeaderStyle, getResizer, getRestoreButton, getShowBody, getShowCloseButton, getShowEdges, getShowFooter, getShowHeader, getShowHeaderBackground, getShowHeaderIcon, getShowMaximizeButton, getShowMinimizeButton, getShowModalMask, getShowResizer, getShowShadow, getShowStatusBar, getShowTitle, getSrc, getStatus, getStatusBar, getTitle, getUseBackMask, maximize, minimize, preloadImages, removeItem, restore, setAnimateMinimize, setAutoCenter, setAutoSize, setBodyColor, setBodyDefaults, setBodyStyle, setBringToFrontOnMouseUp, setCanDragReposition, setCanDragResize, setCanFocusInHeaderButtons, setContentLayout, setContentLayout, setContentsType, setDefaultMinimizeHeight, setDefaultProperties, setDismissOnEscape, setDismissOnOutsideClick, setFillSpaceStyleName, setFooterControls, setFooterHeight, setHeaderControls, setHeaderIcon, setHeaderIcon, setHeaderIconDefaults, setHeaderIconProperties, setHeaderSrc, setHeaderStyle, setHiliteBodyColor, setHiliteHeaderSrc, setHiliteHeaderStyle, setIsModal, setKeepInParentRect, setKeepInParentRect, setLogicalStructure, setMaximized, setMinimizeAcceleration, setMinimized, setMinimizeHeight, setMinimizeTime, setModalMaskOpacity, setModalMaskStyle, setOpacity, setPlacement, setPrintBodyStyle, setPrintHeaderStyle, setShowBody, setShowCloseButton, setShowEdges, setShowFooter, setShowHeader, setShowHeaderBackground, setShowHeaderIcon, setShowMaximizeButton, setShowMinimizeButton, setShowModalMask, setShowResizer, setShowShadow, setShowStatusBar, setShowTitle, setSrc, setStatus, setTitle, setUseBackMask, shouldDismissOnEscape`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersLength, getMembersMargin, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit_Layout, onInit, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, encloses, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoMaskComponents, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeavePageSpace, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinNonEdgeSize, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPanelContainer, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowHover, getShowHoverComponents, getShowResizeBar, getShowSnapGrid, getShrinkElementOnHide, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStyleName, getTabIndex, getTestInstance, getTooltip, getTop, getTopAsString, getTopElement, getUseDragMask, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, printComponents, provideRuleContext, redraw, redraw, removeChild, removeChild, removePeer, removePeer, removeSnapAlignCandidate, resizeBy, resizeTo, resizeTo, revealChild, revealChild, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAllowExternalFilters, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoMaskComponents, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsSnapAlignCandidate, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeavePageSpace, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinNonEdgeSize, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setPadding, setPageLeft, setPageTop, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowHover, setShowHoverComponents, setShowResizeBar, setShowSnapGrid, setShrinkElementOnHide, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStyleName, setTabIndex, setTooltip, setTop, setTop, setUseDragMask, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateEditNode, updateHover, updateHover, updateShadow, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, applyFactoryProperties, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### Portlet

          public Portlet()

    - #### Portlet

          public Portlet(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static Portlet getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `Window`

    - #### setCloseConfirmationDialogProperties

          public void setCloseConfirmationDialogProperties(Dialog closeConfirmationDialogProperties)

      If specified, this properties block will be passed to `isc.confirm()` as the properties parameter when the `closeConfirmationMessage` is shown, allowing developers to customize the appear of the confirmation dialog (modifying its title, etc).
      Parameters:
        `closeConfirmationDialogProperties` - Default value is null
      See Also:
        `SGWTProperties`

    - #### getCloseConfirmationDialogProperties

          public Dialog getCloseConfirmationDialogProperties()

      If specified, this properties block will be passed to `isc.confirm()` as the properties parameter when the `closeConfirmationMessage` is shown, allowing developers to customize the appear of the confirmation dialog (modifying its title, etc).
      Returns:
        Dialog

    - #### setCloseConfirmationMessage

          public void setCloseConfirmationMessage(java.lang.String closeConfirmationMessage)

      Confirmation message to show the user when closing portlets if `showCloseConfirmationMessage` is true.
      Parameters:
        `closeConfirmationMessage` - Default value is "Close portlet?"

    - #### getCloseConfirmationMessage

          public java.lang.String getCloseConfirmationMessage()

      Confirmation message to show the user when closing portlets if `showCloseConfirmationMessage` is true.
      Returns:
        String

    - #### setDestroyOnClose

          public void setDestroyOnClose(java.lang.Boolean destroyOnClose)

      Whether to call `destroy()` when closing the Portlet.
      Parameters:
        `destroyOnClose` - Default value is false

    - #### getDestroyOnClose

          public java.lang.Boolean getDestroyOnClose()

      Whether to call `destroy()` when closing the Portlet.
      Returns:
        Boolean

    - #### setEditProxyConstructor

          public void setEditProxyConstructor(java.lang.String editProxyConstructor)
                                       throws java.lang.IllegalStateException

      Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
      Overrides:
        `setEditProxyConstructor` in class `Window`
      Parameters:
        `editProxyConstructor` - See `SCClassName` . Default value is "PortletEditProxy"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getEditProxyConstructor

          public java.lang.String getEditProxyConstructor()

      Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
      Overrides:
        `getEditProxyConstructor` in class `Window`
      Returns:
        See `SCClassName`

    - #### setMinHeight

          public void setMinHeight(int minHeight)

      Specifies a minimum height for the Portlet. The height of rows within a `PortalLayout` will be adjusted to take into account the minHeight of all the Portlets in that row.
      Overrides:
        `setMinHeight` in class `Canvas`
      Parameters:
        `minHeight` - Default value is 60
      See Also:
        `Canvas.setMinHeight(int)`

    - #### getMinHeight

          public int getMinHeight()

      Specifies a minimum height for the Portlet. The height of rows within a `PortalLayout` will be adjusted to take into account the minHeight of all the Portlets in that row.
      Overrides:
        `getMinHeight` in class `Canvas`
      Returns:
        int
      See Also:
        `Canvas.getMinHeight()`

    - #### setMinWidth

          public void setMinWidth(int minWidth)

      Specifies a minimum width for the Portlet.
      Overrides:
        `setMinWidth` in class `Canvas`
      Parameters:
        `minWidth` - Default value is 70
      See Also:
        `Canvas.setMinWidth(int)`

    - #### getMinWidth

          public int getMinWidth()

      Specifies a minimum width for the Portlet.
      Overrides:
        `getMinWidth` in class `Canvas`
      Returns:
        int
      See Also:
        `Canvas.getMinWidth()`

    - #### setShowCloseConfirmationMessage

          public void setShowCloseConfirmationMessage(java.lang.Boolean showCloseConfirmationMessage)

      If true, `closeConfirmationMessage` will be displayed before portlets are closed
      Parameters:
        `showCloseConfirmationMessage` - Default value is true

    - #### getShowCloseConfirmationMessage

          public java.lang.Boolean getShowCloseConfirmationMessage()

      If true, `closeConfirmationMessage` will be displayed before portlets are closed
      Returns:
        Boolean

    - #### close

          public void close()

      `close()` method overridden to show `closeConfirmationMessage` to the user before removing the portlet from the PortalLayout via `PortalLayout.removePortlet()`
      Overrides:
        `close` in class `Window`

    - #### closeClick

          public void closeClick()

      Handles a click on the close button of this portlet. The default implementation calls `close()`.

      Developers may use `addCloseClickHandler()` to provide custom handling when the user clicks this button. Custom implementations may call `close()` to trigger the default behavior.

    - #### getPortalLayout

          public PortalLayout getPortalLayout()

      Gets the `PortalLayout` which encloses this Portlet (or null, if none).
      Returns:
        the PortalLayout enclosing this Portlet

    - #### getPortalPosition

          public PortalPosition getPortalPosition()

      Gets the position of the Portlet within its `PortalLayout`. Returns null if the Portlet is not in a PortalLayout.
      Returns:
        the position of the Portlet

    - #### setDefaultProperties

          public static void setDefaultProperties(Portlet portletProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `portletProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### setRowHeight

          public void setRowHeight(int rowHeight)

      If you set the rowHeight of a Portlet before adding it to a `PortalLayout`, then the height will be used when creating the new row. If adding the Portlet to an existing row (or dragging it there), the Portlet's rowHeight will be used if the row's height has not already been specified. However, if you set the rowHeight of a Portlet after adding it to the PortalLayout, then the height of the entire row will always be adjusted to match.

      You can also just specify `height` when initializing a Portlet, and it will be applied to the rowHeight when added to a PortalLayout. However, changing the Portlet's height after initialization will not affect the row.

      Note that getting the rowHeight will indicate the rowHeight specified for this Portlet, not the actual height of the row it is in.

      Parameters:
        `rowHeight` - rowHeight Default value is null

    - #### getRowHeight

          public java.lang.Integer getRowHeight()

      If you set the rowHeight of a Portlet before adding it to a `PortalLayout`, then the height will be used when creating the new row. If adding the Portlet to an existing row (or dragging it there), the Portlet's rowHeight will be used if the row's height has not already been specified. However, if you set the rowHeight of a Portlet after adding it to the PortalLayout, then the height of the entire row will always be adjusted to match.

      You can also just specify `height` when initializing a Portlet, and it will be applied to the rowHeight when added to a PortalLayout. However, changing the Portlet's height after initialization will not affect the row.

      Note that getting the rowHeight will indicate the rowHeight specified for this Portlet, not the actual height of the row it is in.

      Returns:
        Integer

    - #### setRowHeight

          public void setRowHeight(java.lang.String rowHeight)

      If you set the rowHeight of a Portlet before adding it to a `PortalLayout`, then the height will be used when creating the new row. If adding the Portlet to an existing row (or dragging it there), the Portlet's rowHeight will be used if the row's height has not already been specified. However, if you set the rowHeight of a Portlet after adding it to the PortalLayout, then the height of the entire row will always be adjusted to match.

      You can also just specify `height` when initializing a Portlet, and it will be applied to the rowHeight when added to a PortalLayout. However, changing the Portlet's height after initialization will not affect the row.

      Note that getting the rowHeight will indicate the rowHeight specified for this Portlet, not the actual height of the row it is in.

      Parameters:
        `rowHeight` - rowHeight Default value is null

    - #### getRowHeightAsString

          public java.lang.String getRowHeightAsString()

      If you set the rowHeight of a Portlet before adding it to a `PortalLayout`, then the height will be used when creating the new row. If adding the Portlet to an existing row (or dragging it there), the Portlet's rowHeight will be used if the row's height has not already been specified. However, if you set the rowHeight of a Portlet after adding it to the PortalLayout, then the height of the entire row will always be adjusted to match.

      You can also just specify `height` when initializing a Portlet, and it will be applied to the rowHeight when added to a PortalLayout. However, changing the Portlet's height after initialization will not affect the row.

      Note that getting the rowHeight will indicate the rowHeight specified for this Portlet, not the actual height of the row it is in.

      Returns:
        String

    - #### setHeight

          public void setHeight(int height)

      If you set the height of a Portlet, then that height will be used as the Portlet's `rowHeight` (if no rowHeight is set).

      After initialization, the `PortalLayout` manages the height of Portlets. If you want to change the height, use `com.smartgwt.client.widgets.layout.PortalLayout#setRowHeight`.

      Overrides:
        `setHeight` in class `Canvas`
      Parameters:
        `height` - height Default value is null
      See Also:
        `Canvas.setHeight(Integer)`

    - #### getHeight

          public java.lang.Integer getHeight()

      If you set the height of a Portlet, then that height will be used as the Portlet's `rowHeight` (if no rowHeight is set).

      After initialization, the `PortalLayout` manages the height of Portlets. If you want to change the height, use `com.smartgwt.client.widgets.layout.PortalLayout#setRowHeight`.

      Overrides:
        `getHeight` in class `Canvas`
      Returns:
        Integer
      See Also:
        `Sizing overview and related methods`

    - #### setHeight

          public void setHeight(java.lang.String height)

      If you set the height of a Portlet, then that height will be used as the Portlet's `rowHeight` (if no rowHeight is set).

      After initialization, the `PortalLayout` manages the height of Portlets. If you want to change the height, use `com.smartgwt.client.widgets.layout.PortalLayout#setRowHeight`.

      Overrides:
        `setHeight` in class `Canvas`
      Parameters:
        `height` - height Default value is null
      See Also:
        `Sizing overview and related methods`

    - #### getHeightAsString

          public java.lang.String getHeightAsString()

      If you set the height of a Portlet, then that height will be used as the Portlet's `rowHeight` (if no rowHeight is set).

      After initialization, the `PortalLayout` manages the height of Portlets. If you want to change the height, use `com.smartgwt.client.widgets.layout.PortalLayout#setRowHeight`.

      Overrides:
        `getHeightAsString` in class `Canvas`
      Returns:
        String

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.layout.PortletLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `Window`